Index: src/Clients/Angular/finki-chattery/src/app/core/services/student-question.service.ts
===================================================================
--- src/Clients/Angular/finki-chattery/src/app/core/services/student-question.service.ts	(revision 9df3069cb12bbfe76a9c6acbb659c84b4fdc33b0)
+++ src/Clients/Angular/finki-chattery/src/app/core/services/student-question.service.ts	(revision e071d3016a15ec432400a873dcc6e8c841b0173c)
@@ -16,3 +16,15 @@
     return this.auth.selfUser?.student?.uid === answerResponse.student.uid;
   }
+
+  currentUserCanDeleteAnswer(answer: AnswerQuestionStateViewModel): boolean {
+    return this.auth.selfUser?.student?.uid === answer.student.uid;
+  }
+
+  currentUserCanNotDeleteAnswerBecauseMarkedCorrectEvenThoughHeIsTheAuthor(answer: AnswerQuestionStateViewModel): boolean {
+    return this.auth.selfUser?.student?.uid === answer.student.uid && answer.correctAnswer;
+  }
+
+  currentUserCanDeleteAnswerResponse(answerResponse: AnswerResponseQuestionStateViewModel): boolean {
+    return this.auth.selfUser?.student?.uid === answerResponse.student.uid;
+  }
 }
Index: src/Clients/Angular/finki-chattery/src/app/core/state/question-facade.service.ts
===================================================================
--- src/Clients/Angular/finki-chattery/src/app/core/state/question-facade.service.ts	(revision 9df3069cb12bbfe76a9c6acbb659c84b4fdc33b0)
+++ src/Clients/Angular/finki-chattery/src/app/core/state/question-facade.service.ts	(revision e071d3016a15ec432400a873dcc6e8c841b0173c)
@@ -15,4 +15,6 @@
 import {
   AnswerQuestion,
+  DeleteAnswer,
+  DeleteAnswerResponse,
   EditAnswerQuestion,
   EditAnswerResponse,
@@ -101,4 +103,12 @@
   }
 
+  public deleteAnswerResponse(answerUid: string, questionUid: string, answerResponseUid: string): void {
+    this.dispatchEffect(new DeleteAnswerResponse(questionUid, answerUid, answerResponseUid));
+  }
+
+  public deleteAnswer(answerUid: string, questionUid: string): void {
+    this.dispatchEffect(new DeleteAnswer(questionUid, answerUid));
+  }
+
   public fetchQuestion(questionUid: string): void {
     this.dispatchEffect(new GetQuestionState(questionUid));
Index: src/Clients/Angular/finki-chattery/src/app/core/state/question-state/question.actions.ts
===================================================================
--- src/Clients/Angular/finki-chattery/src/app/core/state/question-state/question.actions.ts	(revision 9df3069cb12bbfe76a9c6acbb659c84b4fdc33b0)
+++ src/Clients/Angular/finki-chattery/src/app/core/state/question-state/question.actions.ts	(revision e071d3016a15ec432400a873dcc6e8c841b0173c)
@@ -33,7 +33,35 @@
   EditAnswerResponse = '[Question] EditAnswerResponse',
   EditAnswerResponseSuccess = '[Question] EditAnswerResponse Success',
+  DeleteAnswer = '[Question] DeleteAnswer',
+  DeleteAnswerSuccess = '[Question] DeleteAnswer Success',
+  DeleteAnswerResponse = '[Question] DeleteAnswerResponse',
+  DeleteAnswerResponseSuccess = '[Question] DeleteAnswerResponse Success',
   EffectStartedWorking = '[Question] Effect Started Working',
   EffectFinishedWorking = '[Question] Effect Finished Working',
   EffectFinishedWorkingError = '[Question] Effect Finished Working error'
+}
+
+export class DeleteAnswer implements Action {
+  readonly type = QuestionActionTypes.DeleteAnswer;
+
+  constructor(public questionUid: string, public answerUid: string) {}
+}
+
+export class DeleteAnswerSuccess implements Action {
+  readonly type = QuestionActionTypes.DeleteAnswerSuccess;
+
+  constructor(public payload: string) {}
+}
+
+export class DeleteAnswerResponse implements Action {
+  readonly type = QuestionActionTypes.DeleteAnswerResponse;
+
+  constructor(public questionUid: string, public answerUid: string, public answerResponseUid: string) {}
+}
+
+export class DeleteAnswerResponseSuccess implements Action {
+  readonly type = QuestionActionTypes.DeleteAnswerResponseSuccess;
+
+  constructor(public payload: string, public answerUid: string) {}
 }
 
@@ -187,4 +215,6 @@
   | EditAnswerQuestionSuccess
   | EditAnswerResponseSuccess
+  | DeleteAnswerSuccess
+  | DeleteAnswerResponseSuccess
   | EffectStartedWorking
   | EffectFinishedWorking
Index: src/Clients/Angular/finki-chattery/src/app/core/state/question-state/question.effects.ts
===================================================================
--- src/Clients/Angular/finki-chattery/src/app/core/state/question-state/question.effects.ts	(revision 9df3069cb12bbfe76a9c6acbb659c84b4fdc33b0)
+++ src/Clients/Angular/finki-chattery/src/app/core/state/question-state/question.effects.ts	(revision e071d3016a15ec432400a873dcc6e8c841b0173c)
@@ -19,4 +19,8 @@
   AnswerQuestion,
   AnswerQuestionSuccess,
+  DeleteAnswer,
+  DeleteAnswerResponse,
+  DeleteAnswerResponseSuccess,
+  DeleteAnswerSuccess,
   EditAnswerQuestion,
   EditAnswerQuestionSuccess,
@@ -236,3 +240,31 @@
     );
   });
+
+  deleteResponseToAnswer$ = createEffect(() => {
+    return this.actions$.pipe(
+      ofType<DeleteAnswerResponse>(QuestionActionTypes.DeleteAnswerResponse),
+      mergeMap((action) => {
+        return this.api
+          .delete<string>(`v1/questions/${action.questionUid}/answers/${action.answerUid}/answerresponses/${action.answerResponseUid}`)
+          .pipe(
+            tap((state) => this.notification.successNotification('success-delete-answer-response')),
+            switchMap((state) => [new DeleteAnswerResponseSuccess(state, action.answerUid), new EffectFinishedWorking()]),
+            catchError((err) => [new EffectFinishedWorkingError(err)])
+          );
+      })
+    );
+  });
+
+  deleteAnswer$ = createEffect(() => {
+    return this.actions$.pipe(
+      ofType<DeleteAnswer>(QuestionActionTypes.DeleteAnswer),
+      mergeMap((action) => {
+        return this.api.delete<string>(`v1/questions/${action.questionUid}/answers/${action.answerUid}`).pipe(
+          tap((state) => this.notification.successNotification('success-delete-answer')),
+          switchMap((state) => [new DeleteAnswerSuccess(state), new EffectFinishedWorking()]),
+          catchError((err) => [new EffectFinishedWorkingError(err)])
+        );
+      })
+    );
+  });
 }
Index: src/Clients/Angular/finki-chattery/src/app/core/state/question-state/question.reducers.ts
===================================================================
--- src/Clients/Angular/finki-chattery/src/app/core/state/question-state/question.reducers.ts	(revision 9df3069cb12bbfe76a9c6acbb659c84b4fdc33b0)
+++ src/Clients/Angular/finki-chattery/src/app/core/state/question-state/question.reducers.ts	(revision e071d3016a15ec432400a873dcc6e8c841b0173c)
@@ -162,4 +162,43 @@
       };
     }
+    case QuestionActionTypes.DeleteAnswerSuccess: {
+      if (state.question) {
+        return {
+          ...state,
+          question: {
+            ...state.question,
+            answers: state.question.answers.filter((x) => x.uid !== action.payload)
+          }
+        };
+      }
+
+      return {
+        ...state
+      };
+    }
+    case QuestionActionTypes.DeleteAnswerResponseSuccess: {
+      if (state.question) {
+        return {
+          ...state,
+          question: {
+            ...state.question,
+            answers: state.question.answers.map((x) => {
+              if (x.uid === action.answerUid) {
+                return {
+                  ...x,
+                  answerResponses: x.answerResponses.filter((y) => y.uid !== action.payload)
+                };
+              }
+
+              return x;
+            })
+          }
+        };
+      }
+
+      return {
+        ...state
+      };
+    }
     case QuestionActionTypes.AnswerQuestionSuccess: {
       if (state.question) {
Index: src/Clients/Angular/finki-chattery/src/app/shared-app/components/components.ts
===================================================================
--- src/Clients/Angular/finki-chattery/src/app/shared-app/components/components.ts	(revision 9df3069cb12bbfe76a9c6acbb659c84b4fdc33b0)
+++ src/Clients/Angular/finki-chattery/src/app/shared-app/components/components.ts	(revision e071d3016a15ec432400a873dcc6e8c841b0173c)
@@ -1,3 +1,4 @@
 import { ButtonComponent } from './generic/button/button.component';
+import { DeleteConfirmDialogComponent } from './generic/delete-confirm-dialog/delete-confirm-dialog.component';
 import { FileUploadComponent } from './generic/file-upload/file-upload.component';
 import { FormErrorComponent } from './generic/form-error/form-error.component';
@@ -32,4 +33,5 @@
   AnswerQuestionComponent,
   EditAnswerDialogComponent,
-  EditAnswerResponseDialogComponent
+  EditAnswerResponseDialogComponent,
+  DeleteConfirmDialogComponent
 ];
Index: src/Clients/Angular/finki-chattery/src/app/shared-app/components/generic/delete-confirm-dialog/delete-confirm-dialog.component.html
===================================================================
--- src/Clients/Angular/finki-chattery/src/app/shared-app/components/generic/delete-confirm-dialog/delete-confirm-dialog.component.html	(revision e071d3016a15ec432400a873dcc6e8c841b0173c)
+++ src/Clients/Angular/finki-chattery/src/app/shared-app/components/generic/delete-confirm-dialog/delete-confirm-dialog.component.html	(revision e071d3016a15ec432400a873dcc6e8c841b0173c)
@@ -0,0 +1,10 @@
+<h1 mat-dialog-title>{{ title | translate }}</h1>
+<mat-dialog-content> </mat-dialog-content>
+<mat-dialog-actions>
+  <app-button class="margin-right-sm" [buttonType]="ButtonType.Basic" (action)="dialogRef.close()">
+    {{ 'close-button' | translate }}
+  </app-button>
+  <app-button [buttonType]="ButtonType.Warn" (action)="dialogRef.close(true)">
+    {{ 'delete-button' | translate }}
+  </app-button>
+</mat-dialog-actions>
Index: src/Clients/Angular/finki-chattery/src/app/shared-app/components/generic/delete-confirm-dialog/delete-confirm-dialog.component.spec.ts
===================================================================
--- src/Clients/Angular/finki-chattery/src/app/shared-app/components/generic/delete-confirm-dialog/delete-confirm-dialog.component.spec.ts	(revision e071d3016a15ec432400a873dcc6e8c841b0173c)
+++ src/Clients/Angular/finki-chattery/src/app/shared-app/components/generic/delete-confirm-dialog/delete-confirm-dialog.component.spec.ts	(revision e071d3016a15ec432400a873dcc6e8c841b0173c)
@@ -0,0 +1,25 @@
+import { ComponentFixture, TestBed } from '@angular/core/testing';
+
+import { DeleteConfirmDialogComponent } from './delete-confirm-dialog.component';
+
+describe('DeleteConfirmDialogComponent', () => {
+  let component: DeleteConfirmDialogComponent;
+  let fixture: ComponentFixture<DeleteConfirmDialogComponent>;
+
+  beforeEach(async () => {
+    await TestBed.configureTestingModule({
+      declarations: [ DeleteConfirmDialogComponent ]
+    })
+    .compileComponents();
+  });
+
+  beforeEach(() => {
+    fixture = TestBed.createComponent(DeleteConfirmDialogComponent);
+    component = fixture.componentInstance;
+    fixture.detectChanges();
+  });
+
+  it('should create', () => {
+    expect(component).toBeTruthy();
+  });
+});
Index: src/Clients/Angular/finki-chattery/src/app/shared-app/components/generic/delete-confirm-dialog/delete-confirm-dialog.component.ts
===================================================================
--- src/Clients/Angular/finki-chattery/src/app/shared-app/components/generic/delete-confirm-dialog/delete-confirm-dialog.component.ts	(revision e071d3016a15ec432400a873dcc6e8c841b0173c)
+++ src/Clients/Angular/finki-chattery/src/app/shared-app/components/generic/delete-confirm-dialog/delete-confirm-dialog.component.ts	(revision e071d3016a15ec432400a873dcc6e8c841b0173c)
@@ -0,0 +1,17 @@
+import { Component, OnInit } from '@angular/core';
+import { MatDialogRef } from '@angular/material/dialog';
+import { ButtonType } from '../button/button.models';
+
+@Component({
+  selector: 'app-delete-confirm-dialog',
+  templateUrl: './delete-confirm-dialog.component.html',
+  styleUrls: ['./delete-confirm-dialog.component.scss']
+})
+export class DeleteConfirmDialogComponent implements OnInit {
+  title = 'delete-basic-title';
+  ButtonType = ButtonType;
+
+  constructor(public dialogRef: MatDialogRef<DeleteConfirmDialogComponent>) {}
+
+  ngOnInit(): void {}
+}
Index: src/Clients/Angular/finki-chattery/src/app/shared-app/components/question/question-preview/question-preview.component.html
===================================================================
--- src/Clients/Angular/finki-chattery/src/app/shared-app/components/question/question-preview/question-preview.component.html	(revision 9df3069cb12bbfe76a9c6acbb659c84b4fdc33b0)
+++ src/Clients/Angular/finki-chattery/src/app/shared-app/components/question/question-preview/question-preview.component.html	(revision e071d3016a15ec432400a873dcc6e8c841b0173c)
@@ -48,8 +48,14 @@
               {{ answerResponse.createdOn | momentDate: 'LL' }}
               <span
-                class="cursor text-bold"
+                class="cursor text-bold padding-right-sm"
                 *ngIf="studentQuestion.currentUserCanEditAnswerResponse(answerResponse)"
                 (click)="editAnswerResponse(question.uid, answer.uid, answerResponse.uid, answerResponse.text)"
                 >{{ 'question-preview-edit-answer-response' | translate }}</span
+              >
+              <span
+                class="cursor text-bold"
+                *ngIf="studentQuestion.currentUserCanDeleteAnswerResponse(answerResponse)"
+                (click)="deleteAnswerResponse(question.uid, answer.uid, answerResponse.uid)"
+                >{{ 'delete-button' | translate }}</span
               >
               <hr />
@@ -68,4 +74,13 @@
           >{{ 'question-preview-edit-answer' | translate }}</app-button
         >
+        <app-button
+          *ngIf="studentQuestion.currentUserCanDeleteAnswer(answer)"
+          [disabled]="studentQuestion.currentUserCanNotDeleteAnswerBecauseMarkedCorrectEvenThoughHeIsTheAuthor(answer)"
+          matTooltip="{{ 'question-preview-can-not-delete-because-marked-correct' | translate }}"
+          [matTooltipDisabled]="!studentQuestion.currentUserCanNotDeleteAnswerBecauseMarkedCorrectEvenThoughHeIsTheAuthor(answer)"
+          (action)="deleteAnswer(question.uid, answer.uid)"
+          [buttonType]="ButtonType.Basic"
+          >{{ 'delete-button' | translate }}</app-button
+        >
       </mat-card-actions>
     </mat-card>
Index: src/Clients/Angular/finki-chattery/src/app/shared-app/components/question/question-preview/question-preview.component.ts
===================================================================
--- src/Clients/Angular/finki-chattery/src/app/shared-app/components/question/question-preview/question-preview.component.ts	(revision 9df3069cb12bbfe76a9c6acbb659c84b4fdc33b0)
+++ src/Clients/Angular/finki-chattery/src/app/shared-app/components/question/question-preview/question-preview.component.ts	(revision e071d3016a15ec432400a873dcc6e8c841b0173c)
@@ -58,3 +58,19 @@
     this.dialog.editResponseToAnswer(questionUid, answerUid, answerResponseUid, text);
   }
+
+  deleteAnswer(questionUid: string, answerUid: string): void {
+    this.dialog.confirmDelete().subscribe((canDelete) => {
+      if (canDelete) {
+        this.questionFacade.deleteAnswer(answerUid, questionUid);
+      }
+    });
+  }
+
+  deleteAnswerResponse(questionUid: string, answerUid: string, answerResponseUid: string): void {
+    this.dialog.confirmDelete().subscribe((canDelete) => {
+      if (canDelete) {
+        this.questionFacade.deleteAnswerResponse(answerUid, questionUid, answerResponseUid);
+      }
+    });
+  }
 }
Index: src/Clients/Angular/finki-chattery/src/app/shared-app/services/shared-dialog.service.ts
===================================================================
--- src/Clients/Angular/finki-chattery/src/app/shared-app/services/shared-dialog.service.ts	(revision 9df3069cb12bbfe76a9c6acbb659c84b4fdc33b0)
+++ src/Clients/Angular/finki-chattery/src/app/shared-app/services/shared-dialog.service.ts	(revision e071d3016a15ec432400a873dcc6e8c841b0173c)
@@ -2,4 +2,5 @@
 import { MatDialog, MatDialogRef } from '@angular/material/dialog';
 import { Observable } from 'rxjs';
+import { DeleteConfirmDialogComponent } from '../components/generic/delete-confirm-dialog/delete-confirm-dialog.component';
 import { EditAnswerDialogComponent } from '../components/question/edit-answer-dialog/edit-answer-dialog.component';
 // tslint:disable-next-line: max-line-length
@@ -54,3 +55,17 @@
     return dialogRef.afterClosed();
   }
+
+  public confirmDelete(title?: string): Observable<any> {
+    let dialogRef: MatDialogRef<DeleteConfirmDialogComponent>;
+    dialogRef = this.dialog.open(DeleteConfirmDialogComponent, {
+      width: '650px',
+      height: 'auto'
+    });
+
+    if (title) {
+      dialogRef.componentInstance.title = title;
+    }
+
+    return dialogRef.afterClosed();
+  }
 }
Index: src/Clients/Angular/finki-chattery/src/assets/translations/en.json
===================================================================
--- src/Clients/Angular/finki-chattery/src/assets/translations/en.json	(revision 9df3069cb12bbfe76a9c6acbb659c84b4fdc33b0)
+++ src/Clients/Angular/finki-chattery/src/assets/translations/en.json	(revision e071d3016a15ec432400a873dcc6e8c841b0173c)
@@ -73,4 +73,9 @@
   "question-preview-edit-answer": "Edit answer",
   "question-preview-edit-answer-response": "Edit response",
+  "success-delete-answer-response": "Successfully deleted answer response",
+  "success-delete-answer": "Successfully deleted answer",
+  "delete-button": "Delete",
+  "delete-basic-title": "Are you sure you want to delete this?",
+  "question-preview-can-not-delete-because-marked-correct": "Even though you are the author of the answer, it can not be deleted because it's marked as correct by the user who asked the question",
   "StudentDoesNotOwnQuestion": "You do not own this question",
   "AnswerAlreadyUpvoted": "You have already upvoted this answer",
